package no.ntnu.vegare.visualizer.client.db;

import java.io.Serializable;

import no.ntnu.vegare.visualizer.client.utils.GeoIP;

import com.maxmind.geoip.Location;

/**
 * <p>Bean holding a single log event record.</p>
 * 
 * <p>Generated by the <code>DataGenerator</code> or received from the server
 * through the <code>ServerPollDaemon</code>.</p>
 * 
 * @author vegare
 *
 */
public class LogEntry implements Serializable {

	private static final long serialVersionUID = 6313143840402650408L;
	
	private int id;
	private int timestamp;
	private int severity;
	private String facility;
	private String ipaddress;
	private String message;
	
	private Location location;
	
	public LogEntry() {

		id = 0;
		timestamp = 0;
		severity = 0;
		facility = "";
		ipaddress = "";
		message = "";
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(int timestamp) {
		this.timestamp = timestamp;
	}

	public String getFacility() {
		return facility;
	}

	public void setFacility(String facility) {
		this.facility = facility;
	}

	public int getSeverity() {
		return severity;
	}

	public void setSeverity(int severity) {
		this.severity = severity;
	}

	public String getIpaddress() {
		return ipaddress;
	}

	public void setIpaddress(String ipaddress) {
		this.ipaddress = ipaddress;	
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public Location getLocation() {
		
		if (location == null)
			location = GeoIP.ipToPoint(ipaddress.trim());
					
		return location;
	}
	
	public String getLocationString() {
		
		if (getLocation() == null)
			return "Unknown";
		else
			return location.city + ", " + location.countryName;
	}
}
