package no.ntnu.vegare.visualizer.client.main.details;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * <p>Handles the browser navigation of the report panel.</p>
 * 
 * @author vegare
 *
 */
public class ReportController implements ActionListener {

	private LogReportSet model;
	private DetailPanel view;

	public ReportController(LogReportSet reportSet, DetailPanel reportPanel) {
		
		this.model = reportSet;
		this.view = reportPanel;
		
		view.addActionListener(this);
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		if ("previous".equals(e.getActionCommand())) {
			model.prevEntry();
		} else if ("next".equals(e.getActionCommand())) {
			model.nextEntry();
		} else if ("reload".equals(e.getActionCommand())) {
			model.reloadCurrent();
			view.updateReportPanel();
		} else if ("home".equals(e.getActionCommand())) {
			model.lastEntry();
		} else if ("history".equals(e.getActionCommand())) {
			model.switchEntry(view.getSelectedIndex());
		}

		if (model.isFirst())	view.toggleButton("previous", false);
		else					view.toggleButton("previous", true);

		if (model.isLast())		view.toggleButton("next", false);
		else					view.toggleButton("next", true);
	}
}
