package no.ntnu.vegare.visualizer.client.main.filter;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import no.ntnu.vegare.visualizer.client.db.AbstractLogDatabase;
import no.ntnu.vegare.visualizer.client.db.LogEntrySet;
import no.ntnu.vegare.visualizer.client.db.QueryFilter;

/**
 * <p>Handles the search and clear actions.</p>
 * 
 * @author vegare
 *
 */
public class FilterController implements ActionListener {

	private LogEntrySet model;
	private FilterPanel view;

	public FilterController(AbstractLogDatabase db, LogEntrySet model, FilterPanel view) {
		
		this.model = model;
		this.view = view;
		
		view.addActionListener(this);
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		
		if ("clear".equals(e.getActionCommand())) {
			view.clearSearch();
		} else if ("search".equals(e.getActionCommand())) {
						
			QueryFilter filter = view.getQueryFilter();
			
			model.setQueryFilter(filter);
		}
	}
}
