package no.ntnu.vegare.visualizer.server;

import no.ntnu.vegare.visualizer.server.db.LogDatabase;
import no.ntnu.vegare.visualizer.server.gui.ServerFrame;

/**
 * The entry point of the visualization mock server, as specified by the 
 * accompanying master's thesis. The server supports three actions:
 * 
 * <ul>
 *  <li>Serve as a HTTP server, supporting unencrypted communication with
 *  a visualization client, using the HTTP library JAX-WS available from
 *  <a href="http://jax-ws.java.net/">http://jax-ws.java.net/</a></li>
 *  <li>Generate random incidents at a specified frequency</li>
 *  <li>Generate incidents as specified by the user</li>
 * </ul>
 * 
 * Notice that this server is purely developed to assist the proof-of-concept,
 * and serves no purpose in a production setting.
 * 
 * @author vegare
 *
 */
public class VisServer {

	public static void main(String[] args) {
		
		LogDatabase db = new LogDatabase();
		
		ServerFrame frame = new ServerFrame(db);
		frame.setVisible(true);
	}
}
